package sdis_2015;

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.logging.*;
import static sdis_2015.SDIS_2015.PAIR_SELECTION;

public class Gsensor {

	public float stateP = -1; // estado local
	public float stateQ = -1; // estado remoto
	public int ID_local = -1; // ID do proprio sensor

	public int x, y, range, cnt_NEIGHBOR;

	public int[] DB_vizinhos = new int[SDIS_2015.MAX_COUNT_SENSORS];

	public MulticastSocket socket;
	public InetAddress group;

	public String[] buffer;
	int Local_id;
	int Neighbor_id;
	float Neighbor_status;

	public static Thread TimerTh;

	public boolean Server_receive = false;

	public boolean DEBUG = false;

	public boolean wait = false;
	public boolean ciclo = true;
	boolean received = false;

	public int cnt = 0; // conta o numero de ACK2
	public float[] state_vector = new float[SDIS_2015.Nciclos];

	public float media = 0;
	public float var = 0;

	public Gsensor(int x, int y, int id, int range, float val) {

		this.x = x;
		this.y = y;
		this.ID_local = id;
		this.range = range;
		this.stateP = val;

	}

	public void Multicast_Init() {

		try {
			this.socket = new MulticastSocket(4446);
			this.group = InetAddress.getByName("228.5.6.7");
			this.socket.joinGroup(this.group);
			this.socket.setSoTimeout(3000);

		} catch (IOException ex) {
			Logger.getLogger(Gsensor.class.getName()).log(Level.SEVERE, null,
					ex);
		}
	}

	public void send_multicast(String op, int ip_random, float value,
			boolean flag) throws IOException {

		byte[] buf = new byte[256];

		String message = op + " " + this.ID_local + " " + ip_random + " "
				+ value + " " + flag + " ";
		buf = message.getBytes();
		DatagramPacket packet = new DatagramPacket(buf, buf.length, this.group,
				4446);

		this.socket.send(packet);
	}

	public String receive_multicast() throws IOException {
		// = ao que vier do q(destinatario)

		byte[] buf = new byte[256];
		try {
			DatagramPacket packet = new DatagramPacket(buf, buf.length);

			this.socket.receive(packet);
			String recebido = new String(buf, 0, buf.length);

			return recebido;

		} catch (SocketTimeoutException e) {
			return null;
		}
	}

	void processing(String recebido) throws IOException, InterruptedException {

		buffer = recebido.split(" ");
		Local_id = Integer.valueOf(buffer[2]);
		Neighbor_id = Integer.valueOf(buffer[1]);
		Neighbor_status = Float.valueOf(buffer[3]);

		if (Local_id == this.ID_local) {

			if (DEBUG)
				System.out.println(this.ID_local + " recebi do " + Neighbor_id
						+ " " + recebido);
			if (buffer[0].equals("ACK2")) {

				Server_receive = true;

				UPDATE();

			} else if (buffer[0].equals("ACK1")) {

				this.received = true;

				if (buffer[4].equals("false")) { // a mensagem não é repetida?
					this.stateQ = Neighbor_status;
				}
				cnt++;
				if (cnt == 1) {
					this.send_multicast("ACK2", Neighbor_id, this.stateP, false);
					this.UPDATE();
				}

			} else if (buffer[0].equals("MATCH") && this.wait == false) {
				if (PAIR_SELECTION)
					this.wait = true;

				if (DEBUG)
					System.out.println(this.ID_local + " Ouvi " + Neighbor_id);

				this.stateQ = Neighbor_status;
				send_multicast("ACK1", Neighbor_id, this.stateP, false);

				Server_receive = false;
				TimerTh = new Thread(new Timer(this.ID_local, Neighbor_id,
						this.stateP));
				TimerTh.start();
			}
		}

	}

	public void UPDATE() throws InterruptedException {
		this.stateP = ((this.stateP + this.stateQ) / 2);
		Thread.sleep(500);
		this.wait = false;
		if (PAIR_SELECTION)
			this.ciclo = false;
	}

	public int GetNeighbor() throws InterruptedException {

		Random randomGenerator = new Random();
		for (int i = 0; i < this.cnt_NEIGHBOR; i++) {
			int id_random_neighbor = randomGenerator.nextInt(this.cnt_NEIGHBOR);
			id_random_neighbor = this.DB_vizinhos[id_random_neighbor];
			if (SDIS_2015.sensores[id_random_neighbor].wait == false)
				return id_random_neighbor;

		}
		return -1;
	}
}
