package sdis_2015;

import java.util.*;

public class SDIS_2015 {

	public static int MAX_GRID;
	public static int MAX_COUNT_SENSORS;
	public static boolean PAIR_SELECTION; // false== random && true ==
											// Dristributed Solution
	public static boolean UNIFORM_OR_PEAK; // false== uniform && true == peak

	public static int RANGE;
	public static int sensor_count = 0, id_sensor;
	public static int[] coordenada_x;
	public static int[] coordenada_y;
	public static Gsensor[] sensores;

	public static int ciclo = 0;
	public static int tempociclo;
	public static int Nciclos;
	public static boolean start = false;
	public static int start_ciclo = 0;
	public static boolean end = false;
	public static Thread[] ActTh;
	public static Thread[] PassTh;

	public static void main(String[] args) {

		if (args.length != 7) {
			System.out
					.println("Insira <Modo> <Distribuição> <Rede> <Sensores> <Alcance> <Ciclo> <Nciclos>");
			System.out.println("Modo: AL(aleatório) or DS(distribuido)");
			System.out.println("Distribuição: UNI(uniforme) or PK(pico)");
			System.out.println("Rede: tamanho da rede desejada (nxn)");
			System.out.println("Sensores: número de sensores desejados");
			System.out.println("Alcance: Alcence fisico dos sensores");
			System.out.println("Ciclo: Tempo de ciclo em ms");
			System.out.println("NCiclos: Número de ciclos desejados");
			return;
		}

		if (args[0].equals("AL")) {
			PAIR_SELECTION = false;
		} else if (args[0].equals("DS")) {
			PAIR_SELECTION = true;
		} else
			System.out.println("Insira um modo disponibilizado: AL ou DS");

		if (args[1].equals("UNI")) {
			UNIFORM_OR_PEAK = false;
		} else if (args[1].equals("PK")) {
			UNIFORM_OR_PEAK = true;
		} else
			System.out
					.println("Insira uma distribuição disponibilizada: UNI ou PK");

		MAX_GRID = Integer.valueOf(args[2]);
		MAX_COUNT_SENSORS = Integer.valueOf(args[3]);
		RANGE = Integer.valueOf(args[4]);
		tempociclo = Integer.valueOf(args[5]);
		Nciclos = Integer.valueOf(args[6]);

		if (MAX_GRID * MAX_GRID < MAX_COUNT_SENSORS) {
			System.out
					.println("Reduza número de sensores para a rede escolhida");
			return;
		}

		coordenada_x = new int[MAX_COUNT_SENSORS];
		coordenada_y = new int[MAX_COUNT_SENSORS];
		sensores = new Gsensor[MAX_COUNT_SENSORS];
		ActTh = new Thread[MAX_COUNT_SENSORS];
		PassTh = new Thread[MAX_COUNT_SENSORS];

		float number;
		if (UNIFORM_OR_PEAK)
			number = MAX_COUNT_SENSORS;
		else
			number = (float) Math.random();

		if (!PAIR_SELECTION && UNIFORM_OR_PEAK) {
			System.out.println(" Try GetPair Random uniform");
			return;
		}

		for (int i = 0; i < MAX_COUNT_SENSORS; i++) {
			coordenada_x[i] = 0;
			coordenada_y[i] = 0;
			sensores[i] = new Gsensor(0, 0, 0, 0, 0);

		}

		Random randomGenerator = new Random();

		for (int i = 0; i < MAX_COUNT_SENSORS; i++) { // serve para gerar e
														// verificar se ja exite
														// // coordenadas iguais
			int aux_x = randomGenerator.nextInt(MAX_GRID);
			int aux_y = randomGenerator.nextInt(MAX_GRID);
			for (int j = 0; j < i; j++) {
				if ((aux_x == coordenada_x[j]) && (aux_y == coordenada_y[j])) {
					i--;
					break;
				} else { //
					coordenada_x[i] = aux_x;
					coordenada_y[i] = aux_y;
					sensores[i] = new Gsensor(coordenada_x[i], coordenada_y[i],
							i, RANGE, number);

					if (UNIFORM_OR_PEAK)
						number = 0;
					else
						number = (float) Math.random();

				}
			}
		}

		// DEBUG- posição sensores
		for (int i = 0; i < MAX_COUNT_SENSORS; i++)
			System.out.println(i + " X: " + sensores[i].x + " Y: "
					+ sensores[i].y);

		// Cada sensor verificar quem é o seu vizinho
		for (int i = 0; i < MAX_COUNT_SENSORS; i++) { // ID do sensor epicentro
			int aix = 0;
			int cnt = 0;
			for (int j = 0; j < MAX_COUNT_SENSORS; j++) {
				if (sensores[j].ID_local != sensores[i].ID_local) {

					// Valida a sua vizinhança com a equação da
					// circunferencia ((x-a)^2)+((y-b)^2)=r^2
					double result = Math
							.pow((sensores[j].x - sensores[i].x), 2)
							+ Math.pow((sensores[j].y - sensores[i].y), 2);
					double result_range = Math.pow(RANGE, 2);

					if (result <= result_range) {

						sensores[i].DB_vizinhos[aix] = sensores[j].ID_local;
						aix++; // contabilizar o numero de vizinhos
						sensores[i].cnt_NEIGHBOR = aix;
						cnt++;

					}
				}
			}
			System.out.println("ID " + i + "  " + cnt);
		}

		// ********************** LANCAR THREADS **************************

		for (int i = 0; i < MAX_COUNT_SENSORS; i++) {
			ActTh[i] = new Thread(new Active(i));
			PassTh[i] = new Thread(new Passive(i));

			SDIS_2015.sensores[i].Multicast_Init();

			ActTh[i].start();
			PassTh[i].start();
		}

		Thread show_ciclos = new Thread(new show());
		show_ciclos.start();

		int vezciclo = 0;
		int Comunica = MAX_COUNT_SENSORS;

		while (show_ciclos.isAlive()) {

			try {
				Thread.sleep(0, 1); // 1 nanosecond.
			} catch (InterruptedException ex) {
				Thread.currentThread().interrupt();
			}

			if (start_ciclo == 1) {

				if ((Comunica != MAX_COUNT_SENSORS) && PAIR_SELECTION) {
					System.out.println("Aumente ao tempo de ciclo");
					System.out.println("Falha na comunicação de "
							+ (MAX_COUNT_SENSORS - Comunica));
				}
				System.out.println("Novo ciclo");
				start_ciclo = 0;
				vezciclo = 0;
				start = true;

				for (int i = 0; i < MAX_COUNT_SENSORS; i++) {
					sensores[i].ciclo = true;
				}
			}
			Comunica = 0;
			for (int i = 0; i < SDIS_2015.MAX_COUNT_SENSORS; i++) {
				if (SDIS_2015.sensores[i].ciclo == false) {
					Comunica++;
				}
			}

			if (Comunica == MAX_COUNT_SENSORS && vezciclo == 0) {
				System.out.println("todos comunicaram");
				vezciclo = 1;
			}
		}
		end = true;

	}
}